'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.propify = undefined;

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _pick = require('lodash/pick');

var _pick2 = _interopRequireDefault(_pick);

var _get = require('lodash/get');

var _get2 = _interopRequireDefault(_get);

var _reduce = require('lodash/reduce');

var _reduce2 = _interopRequireDefault(_reduce);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function propsToProps() {
  var prop = arguments.length <= 0 ? undefined : arguments[0];

  if (!prop) return {};

  if (prop !== null && (typeof prop === 'undefined' ? 'undefined' : _typeof(prop)) === 'object') {
    return prop;
  }

  return { context: prop };
}

function getMountableComponent(Component) {
  var props = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

  return typeof Component === 'function' ? _react2.default.createElement(Component, props) : _react2.default.cloneElement(Component, props);
}

var propify = exports.propify = function propify(Component) {
  var mapPropsToProps = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : propsToProps;
  return function () {

    // Why
    if (arguments.length === 0) {
      var Comp = getMountableComponent(Component);
      return _react2.default.createElement(Comp, null);
    }

    var propMapper = (0, _get2.default)(Component, 'mapPropsToProps', (0, _get2.default)(Component, 'type.mapPropsToProps', mapPropsToProps));

    // The default. Call the map function if it is a function.
    if (typeof propMapper === 'function') {
      var _Comp = getMountableComponent(Component, propMapper.apply(undefined, arguments));
      return _Comp;
    }

    var props = void 0;
    var firstArg = arguments.length <= 0 ? undefined : arguments[0];

    // The rest assume that the firstArg is an object. Check that that is the case.
    if (!propMapper || !firstArg) {
      props = { context: firstArg };
    } else if (Array.isArray(propMapper)) {
      props = (0, _pick2.default)(firstArg, propMapper);
    } else if (propMapper !== null && (typeof propMapper === 'undefined' ? 'undefined' : _typeof(propMapper)) === 'object') {
      props = (0, _reduce2.default)(propMapper, function (pickedProps, propToPick, propName) {
        pickedProps[propName] = (0, _get2.default)(firstArg, propToPick, null);
        return pickedProps;
      }, {});
    } else if (typeof propMapper === 'string') {
      props = _defineProperty({}, propMapper, firstArg);
    }

    return getMountableComponent(Component, props);
  };
};